using Domain;
using Presenter;
using TMPro;
using UnityEngine;

namespace View.UI {
	public class ScoreView : MonoBehaviour, IScoreView {
		[SerializeField] private TMP_Text text;

		private ExpressionClick _click;
		private CustomInput _customInput;

		private void Start() {
			_click = FindObjectOfType<Dependencies>().ExpressionClick;
			_customInput = FindObjectOfType<Dependencies>().CustomInput;
		}

		private void Update() =>
			CheckInput();

		public void UpdateView(int score) =>
			text.text = score.ToString();

		private void CheckInput() {
			_customInput.UpdateInput();

			if (_customInput.AnyKeyDown())
				_click.Execute();
		}
	}
}